#include "impcreatetemplate.h"
#include "mainwindow.h"
#include "ui_mainwindow.h"

#include "common.h"

IMPcreateTemplate::IMPcreateTemplate(QWidget *parent) :
    QMainWindow(parent)
{

}







//---------------------------------------------------//
// Impulus応答テンプレート作成処理
//---------------------------------------------------//
void MainWindow::IMPcreateTemplate()
{

    try
    {
        double elvfrom    = 0; // 仰角開始
        double elvint     = 0; // 仰角間隔
        double elvto      = 0;
        int numelv        = 0; // 仰角数

        double heightfrom = 0; // 高さ開始
        double heightto   = 0; // 高さ終了
        double heightint  = 0; // 高さ間隔

        double hcount     = 0;
        double tcount     = 0;
        double azifrom    = 0; //方位角
        double azito      = 0;
        double aziint     = 0;
		int numazi        = 0; //方位角数

        int numheight     = 0; // 高さ数
        int result =0;
        int mic_cnt = 0;



        qDebug("createTemplate [%s][%d]\n" , __FILE__, __LINE__ );

        //--------------------------------------------------------//
        // 球面座標 or 円柱座標 check
        //--------------------------------------------------------//
        int coordinate = 0;

        if (ui->imp_spherical->isChecked()) //球面座標?
        {
            coordinate = 0; //球面座標
        }
        else
        {
            coordinate = 1; //円柱座標
        }



        //--------------------------------------------------------//
        // radius(距離)
        //--------------------------------------------------------//
        double radius = ui->imp_radiusfrom->value();



        switch(coordinate)
        {
        //------------------------------------------------------------//
        //  球面座標                                                  //
        //------------------------------------------------------------//
        case 0:
            {
                //--------------------------------------------------------//
                // elevation(仰角)
                //--------------------------------------------------------//
                elvfrom = ui->imp_elvfrom->value(); // 仰角開始
                elvto   = ui->imp_elvto->value();   // 仰角終了
                elvint  = ui->imp_elvint->value();  // 仰角間隔

				numelv = CalcNumelv( elvfrom , elvto, elvint);

                break;
            }
        //------------------------------------------------------------//
        //  円柱座標                                                  //
        //------------------------------------------------------------//
        default:
            //--------------------------------------------------------//
            // height(高さ)
            //--------------------------------------------------------//
            heightfrom = ui->imp_heightfrom->value(); // 高さ開始
            heightto   = ui->imp_heightto->value();
            heightint  = ui->imp_heightint->value(); // 高さ間隔

			numheight = CalcNumheight( heightfrom   // 高さ開始
						 	  		  , heightto    // 高さ終了
							          , heightint); // 高さ間隔
									  		
            break;
        }//switch


        //--------------------------------------------------------//
        // AZIMUTH(方位角)
        //--------------------------------------------------------//
         azifrom = ui->imp_azifrom->value(); // 方位角開始
         azito   = ui->imp_azito->value();   // 方位角終了
         aziint = ui->imp_aziint->value();   //方位角間隔

		 numazi = CalcNumazi( azifrom,  azito,  aziint);


        //--------------------------------------------------------//
		// ファイル名テンプレート
        //--------------------------------------------------------//
        QString list_file_template = ui->imp_filename->text();  


        //--------------------------------------------------------//
        // チャンネルリスト
        //--------------------------------------------------------//
        QString channel_list        = ui->imp_mic_list->text();                  // チャンネルリスト
        QString use_channel_list    = (ui->imp_mic_flg->isChecked()? "" : "#");  // チャンネルリストチェックボックスON


        //--------------------------------------------------------//
        // cut
        //--------------------------------------------------------//
        int offset_start = ui->imp_cut_start->value();          // cut開始
        int offset_end   = ui->imp_cut_end->value();            // cut終了



        // 一時ディレクトリを生成
        boost::filesystem::path temp_dir = CreateTemporaryDirectory();
        boost::filesystem::path hark_config_file_path = temp_dir / "ImpulseResponseListFile.xml";

        qDebug() << "hark_config_file_path.c_str() =" << hark_config_file_path.c_str() ;


        //mic数をカウント
        if(ui->imp_mic_flg->isChecked() == true )
        {
            char c;

            for (int i =0 ; i < channel_list.length();i++)
            {
                 c = channel_list.toStdString().c_str()[i];
                if(c == ',' )
                {
                    mic_cnt++;
                }
            }

            mic_cnt++; //文字数カウントのため +1

        }
        else
        {
            mic_cnt = 8;
            channel_list = "0,1,2,3,4,5,6,7";
        }

        qDebug("mic_cnt[%d]\n",mic_cnt);
        qDebug("channel_list[%s]\n", channel_list.toStdString().c_str());




        switch(coordinate)
        {
            //------------------------------------------------------------//
            //  球面座標(仰角)                                             //
            //------------------------------------------------------------//
            case 0:
            {
                qDebug("*------------------ 球面座標(仰角) ---------------------------------------*\n");
            	qDebug((boost::format("harktool4_cui "
                                                    "--mode template "
                                                    "--output-file %s "
                                                    "--output-format xml "
                                                    "--output-type ir "
                                                    "--nummic %d "
                                                    "--azifrom %f --aziint %f --numazi %d "
                                                    "--elvfrom %f --elvint %f --numelv %d "
                                                    "--radius %f "
                                                    "--cut-start %d "
                                                    "--cut-end %d "
                                                    "--filepath %s "
                                                    "--mic-channels %s "
                                                 )

                                   % hark_config_file_path
                                   % mic_cnt
                                   % azifrom % aziint % numazi
                                   % elvfrom % elvint % numelv
                                   % radius
                                   % offset_start
                                   % offset_end
                                   % list_file_template.toStdString()
                                   % channel_list.toStdString()).str().c_str()) ;

                qDebug("*---------------------------------------------------------*\n");




            // ImpulseResponseFileを作成
            result = ::system((boost::format("harktool4_cui "
                                                    "--mode template "
                                                    "--output-file %s "
                                                    "--output-format xml "
                                                    "--output-type ir "
                                                    "--nummic %d "
                                                    "--azifrom %f --aziint %f --numazi %d "
                                                    "--elvfrom %f --elvint %f --numelv %d "
                                                    "--radius %f "
                                                    "--cut-start %d "
                                                    "--cut-end %d "
                                                    "--filepath %s "
                                                    "--mic-channels %s "
                                                 )

                                   % hark_config_file_path
                                   % mic_cnt
                                   % azifrom % aziint % numazi
                                   % elvfrom % elvint % numelv
                                   % radius
                                   % offset_start
                                   % offset_end
                                   % list_file_template.toStdString()
                                   % channel_list.toStdString()).str().c_str()) ;

        }
            break;

        //------------------------------------------------------------//
        //  円柱座標(高さ使用)                                         //
        //------------------------------------------------------------//
        default:

            qDebug("*-------------------- 円柱座標(高さ使用) -------------------------------------*\n");
            qDebug((boost::format("harktool4_cui "
                            "--mode template "
                            "--output-file %s "
                            "--output-format xml "
                            "--output-type ir "
                            "--nummic %d "
                            "--azifrom %f    --aziint %f    --numazi %d "
                            "--heightfrom %f --heightint %f --numheight %d "
                            "--radius %f "
                            "--cut-start %d "
                            "--cut-end %d "
                            "--filepath %s "
                            "--mic-channels %s "
                            )
                        % hark_config_file_path
                        % mic_cnt
                        % azifrom % aziint % numazi
                        % heightfrom % heightint % numheight
                        % radius
                        % offset_start
                        % offset_end
                        % list_file_template.toStdString()
                        % channel_list.toStdString()).str().c_str());
          



            qDebug("*---------------------------------------------------------*\n");


            result = ::system((boost::format("harktool4_cui "
                            "--mode template "
                            "--output-file %s "
                            "--output-format xml "
                            "--output-type ir "
                            "--nummic %d "
                            "--azifrom %f    --aziint %f    --numazi %d "
                            "--heightfrom %f --heightint %f --numheight %d "
                            "--radius %f "
                            "--cut-start %d "
                            "--cut-end %d "
                            "--filepath %s "
                            "--mic-channels %s "
                            )
                        % hark_config_file_path
                        % mic_cnt
                        % azifrom % aziint % numazi
                        % heightfrom % heightint % numheight
                        % radius
                        % offset_start
                        % offset_end
                        % list_file_template.toStdString()
                        % channel_list.toStdString()).str().c_str());

        }//swutch


        if (result != 0)
        {
            THROW_CRITICAL(trUtf8("harktool4_cuiコマンドを正常に実行できませんでした"));
            return;
        }


        //-----------------------------------------------------------------//
        // 作成したテンプレートを読み込む
        //-----------------------------------------------------------------//
        int ret = ::system((boost::format("tidy -o %s -xml -utf8 -w 255 -c -q -asxml -i %s ")
                                    % hark_config_file_path.c_str()
                                    % hark_config_file_path.c_str()).str().c_str());

        qDebug() << __func__ << "system(tidy)=" << ret;

        QFile hark_config(hark_config_file_path.c_str());

        if (!hark_config.open(QIODevice::ReadOnly))
        {
            THROW_CRITICAL(trUtf8("作成したファイルを読み込めませんでした"));
            return;
        }

        QTextStream inbuf(&hark_config);
        QString outbuf = inbuf.readAll();
        qDebug() << outbuf;

        ui->imp_textEdit->setStyleSheet(" color: white;font: bold 16px;");
        ui->imp_textEdit->setText(outbuf);
        qDebug() << "harktool4_cui Ok" ;


        //-----------------------------------------------------------------//
        // テンポラリdir削除
        //-----------------------------------------------------------------//
		std::string temp = (boost::format("rm -rf %s") % temp_dir).str();
		::system(temp.c_str());
		m_plotctl[m_out_page_no].imp_hark_path = "";

        return;

    }
    catch (std::exception& exp)
    {
        THROW_CRITICAL(exp.what());
        return;
    }
    catch (...)
    {
        THROW_CRITICAL(trUtf8("unexpected error"));
    }

}




